/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_EXERFISICO                           				      */
/* Tabela : EXERFISICO                                                    				      */
/*                                                                      					      */
/* Criao:                                                              				      */
/* 13/12/2004 - Rafael dos Santos Lopes                           				      */
/*                                                                    					      */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_EXERFISICO
BEFORE INSERT OR UPDATE OR DELETE
ON EXERFISICO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUEXFI := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.DSEXERFISICO,0) <> NVL(:NEW.DSEXERFISICO,0)) OR
           (NVL(:OLD.QTENERCONS,0) <> NVL(:NEW.QTENERCONS,0)) THEN
         :NEW.DTULTATUEXFI := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('EXERFISICO', '', 'CDEXERFISICO='||:OLD.CDEXERFISICO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE EXERFISICO MODIFY DTULTATUEXFI DEFAULT SYSDATE
/

