-- ============================================================
--   TABLE: PRATO
-- ============================================================
DECLARE
   V_CDPAIPRATO VARCHAR(10);
   V_COUNT      NUMBER := 0;
BEGIN
   FOR C_ATUPRATO IN
      (SELECT CDNVPRATO, CDPRATO
         FROM PRATO
      )
   LOOP
      /* BUSCANDO O PAI DO PRATO */
      BEGIN
         SELECT CDPRATO
           INTO V_CDPAIPRATO
           FROM PRATO
          WHERE CDNVPRATO = (C_ATUPRATO.CDNVPRATO - 1)
            AND C_ATUPRATO.CDPRATO LIKE CDPRATO||'%';
      EXCEPTION
         WHEN OTHERS THEN
            V_CDPAIPRATO := NULL;
      END;
      /* UPDATANDO O PAI DO PRATO */
      UPDATE PRATO
         SET CDPRATONIVANTE = V_CDPAIPRATO
       WHERE CDPRATO = C_ATUPRATO.CDPRATO;
      V_COUNT := V_COUNT + 1;
      IF V_COUNT >= 5 THEN
         COMMIT;
         V_COUNT := 0;
      END IF;
    END LOOP;
   COMMIT;
END;
/
-- ============================================================
--   TRIGGER: PRATO_PAI
-- ============================================================
/*A Trigger tem o objetivo de atualizar o campo 'CDPRATONIVANTE'
para um prato que acabou de ser inserido*/
CREATE OR REPLACE 
TRIGGER PRATO_PAI
BEFORE INSERT ON PRATO FOR EACH ROW
DECLARE
   V_CDPRATOPAI PRATO.CDPRATO%TYPE;
BEGIN
   /*Caso o prato seja nvel '1', ele no possui nvel superior,
     por isso a varivel recebe valor nulo*/
   IF :NEW.CDNVPRATO = '1' THEN
      V_CDPRATOPAI := NULL;
   ELSE
      /*Seleo do cdigo do prato de nvel superior*/
      SELECT 
         CDPRATO
      INTO 
         V_CDPRATOPAI
      FROM 
         PRATO      
      WHERE 
         (:NEW.CDPRATO LIKE CDPRATO||'%') AND 
         (:NEW.CDNVPRATO - 1) = CDNVPRATO;  
   END IF;
      /*Insero da varivel 'V_CDPRATOPAI' no campo que 
         recebe o cdigo do prato de nvel superior*/
      :NEW.CDPRATONIVANTE := V_CDPRATOPAI; 
END;